//@Kofko

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class M {
    public static void main(String[] args) throws IOException, InterruptedException {
        ExecutorService ex = Executors.newFixedThreadPool(4);
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int N = Integer.parseInt(in.readLine());
        double[][] xyd = new double[4][3];
        int[][] lines = new int[4][75900];
        int[] offsets = new int[4];
        int readSpk = 0;
        for (int i = 0; i < N && readSpk < 4; ++i) {
            double x = Double.parseDouble(in.readLine());
            double y = Double.parseDouble(in.readLine());
            boolean needRead = true;
            if (N - i - 1 >= 4 - readSpk) {
                for (int j = 0; j < readSpk; ++j) {
                    if (getCos(xyd[j], x, y) > 0.9) {
                        needRead = false;
                        break;
                    }
                }
            }
            if (needRead) {
                xyd[readSpk][0] = x;
                xyd[readSpk][1] = y;
                int start = in.read();
                offsets[readSpk] = 1;
                while (in.read() == start) {
                    ++offsets[readSpk];
                }
                in.skip(6496489);
                offsets[readSpk] += 6496490;
                for (int j = 0; j < 75900; ++j) {
                    lines[readSpk][j] = in.read();
                    in.skip(9);
                }
                in.skip(9241000 - offsets[readSpk]);
                in.readLine();
                ex.execute(new Worker(offsets[readSpk], lines[readSpk], xyd[readSpk]));
                ++readSpk;
            } else {
                in.skip(10000000);
                in.readLine();
            }
        }
        ex.shutdown();
        while (!ex.awaitTermination(1, TimeUnit.MILLISECONDS)) ;
        double x = 0;
        double y = 0;
        double v1x = xyd[1][0] - xyd[0][0];
        double v1y = xyd[1][1] - xyd[0][1];
        double v1len = dist(v1x, v1y);
        double r1 = xyd[0][2];
        double r2 = xyd[1][2];
        double cosA = (r1 * r1 + v1len * v1len - r2 * r2) / (2 * r1 * v1len);
        if (cosA > 1) {
            cosA = 1;
        }
        if (cosA < -1) {
            cosA = -1;
        }
        double midX = cosA * r1 * v1x / v1len;
        double midY = cosA * r1 * v1y / v1len;
        double v2len = r1 * Math.sqrt(1 - cosA * cosA);
        double[][] pnts = new double[2][2];
        pnts[0][0] = midX + v2len * (-v1y / v1len) + xyd[0][0];
        pnts[0][1] = midY + v2len * (v1x / v1len) + xyd[0][1];
        pnts[1][0] = midX + v2len * (v1y / v1len) + xyd[0][0];
        pnts[1][1] = midY + v2len * (-v1x / v1len) + xyd[0][1];
        if (readSpk == 2) {
            double minDst = 1e10;
            for (double[] pnt : pnts) {
                double pntDst = dist(pnt[0], pnt[1]);
                if (pntDst < minDst) {
                    minDst = pntDst;
                    x = pnt[0];
                    y = pnt[1];
                }
            }
        } else {
            double minDst = 1e10;
            for (double[] pnt : pnts) {
                double spkDst = Math.abs(dist(xyd[2][0], xyd[2][1], pnt[0], pnt[1]) - xyd[2][2]);
                if (spkDst < minDst) {
                    minDst = spkDst;
                    x = pnt[0];
                    y = pnt[1];
                }
            }
        }
        double step = 0.5;
        for (int i = 0; i < 10; ++i) {
            for (int ts = 0; ts < readSpk; ++ts) {
                double[] test = xyd[ts];
                double tmp1 = x - test[0];
                double tmp2 = y - test[1];
                double tmp3 = Math.sqrt(tmp1 * tmp1 + tmp2 * tmp2);
                double tmp4 = 1 - test[2] / tmp3;
                double dx = 2 * tmp1 * tmp4;
                double dy = 2 * tmp2 * tmp4;
                x -= step * dx;
                y -= step * dy;
            }
            step *= 0.5;
        }
        System.out.println(x + " " + y);
    }

    static class Worker implements Runnable {
        int offset;
        int[] line;
        double[] xyd;

        Worker(int offset, int[] line, double[] xyd) {
            this.offset = offset;
            this.line = line;
            this.xyd = xyd;
        }

        @Override
        public void run() {
            int marker = (int) (dist(xyd[0], xyd[1]) / 299.792458) - 12100;
            while (line[--marker] == (int) '1') ;
            int rev = marker;
            int size = 0;
            int delay;
            while (size != 19 && ++marker < 75900) {
                size = line[marker] == (int) '1' ? size + 1 : 0;
            }
            if (size != 19) {
                size = 0;
                while (size != 19) {
                    size = line[--rev] == (int) '1' ? size + 1 : 0;
                }
                delay = (rev - 637548) * 10 + offset;
            } else {
                delay = (marker - 637566) * 10 + offset;
            }
            xyd[2] = delay * 29.9792458;
        }
    }

    static double dist(double a, double b) {
        return Math.sqrt(a * a + b * b);
    }

    static double dist(double ax, double ay, double bx, double by) {
        return dist(ax - bx, ay - by);
    }

    static double getCos(double[] a, double bx, double by) {
        return (a[0] * bx + a[1] * by) / (dist(a[0], a[1]) * dist(bx, by));
    }
}
