//@Nomad1
import java.io.*;
import java.util.*;

public class Contest
{
	static final int SEGMENT=10000000;
	static final int BUFFER=50000;

	static double readDouble(InputStream stream) throws IOException
	{
		char[]data=new char[20];
		int offset=0;
		do{
			char b=(char)stream.read();
			if (b==13||b==10){
				if (offset!=0)
					break;
			} else{
				data[offset]=b;
				offset++;
			}
		} while(offset<data.length);
		return Double.parseDouble(new String(data));
	}
	
	static double process(InputStream stream) throws IOException{
		byte[]buffer=new byte[BUFFER];
		int left=SEGMENT,c1=0,c0=0,phase=-1,doffset=0,offset=0;
		
		while(left>0){
			int read=stream.read(buffer,0,left>BUFFER?BUFFER:left);
			left-=read;
			
			if (phase==-1){
				byte last=-1;
				for(int i=0;i<200;i++)
				{
					byte bit=buffer[i];
					if (bit!='0'&&bit!='1')
					{
						doffset++;
						continue;
					}
					if (bit!=last&&last!=-1)
					{
						phase=-doffset+(i%10);
						break;
					}
					last=bit;
				}
			}
			
			int j=doffset;
			while(j<read&&c1+c0<18)
			{
				byte bit=buffer[j];
				j+=10;
				if (bit=='0'){
					c1=0;
					c0++;
				} else{
					c1++;
					c0=0;
				}
			}
			
			if (c0>=18){
				offset=-read+j-c0*10-427401;
				break;
			}

			if (c1>=18){
				offset=-read+j-c1*10-6375481;
				break;
			}
		}
		
		if (phase!=0)
			offset+=-10+phase;
		offset+=SEGMENT-left;
		
		stream.skip(left+1);
		
		return offset*29.9792458; 
	}
	
	static void circleInt(double[]c1,double[]c2,List<double[]>points){
		double e=c2[0]-c1[0],f=c2[1]-c1[1];
		double p=Math.sqrt(e*e+f*f);
		
		if (p==0)
			return;
		
		double k=p*0.5 + 0.5*(c1[2]*c1[2]-c2[2]*c2[2])/p;
		double h=Math.sqrt(c1[2]*c1[2]-k*k)/p;
		
		double x=c1[0]+e*k/p,y=c1[1]+f*k/p;
		
		points.add(new double[]{x+f*h,y-e*h});
		if (h!=0)
			points.add(new double[]{x-f*h,y+e*h});
	}
	
	static boolean validPoint(double[][]sats,double[]point){
		for(int i=0;i<sats.length;i++){
			double x=sats[i][0]-point[0],y=sats[i][1]-point[1];
			double dist=Math.sqrt(x*x+y*y)-sats[i][2]; 
			
			if (dist>100||(i!=0&&dist<-1000))
				return false;
		}
		
		return true;
	}
	
	static void findPoints(double[][]satellites,List<double[]>points)
	{
		for(int i=0;i<satellites.length;i++)
			for(int j=i+1;j<satellites.length;j++)
				circleInt(satellites[i],satellites[j],points);
		
		double x=0,y=0;
		
		for(int i=0;i<points.size();i++){
			double [] p=points.get(i);

			if (!validPoint(satellites,p)){
				points.remove(i);
				i--;
			} else{
				x+=p[0];y+=p[1];
			}
		}
		
		x/=points.size();
		y/=points.size();
		
		System.out.println((float)x+" "+(float)y);
	}
	
	public static void main(String[]args){
		try{
			InputStream s=System.in;
			int nsats=(int)readDouble(s);
			
			double[][]sats=new double[nsats + 1][];
			sats[0]=new double[]{0,0,6378000};
			
			List<double[]>points=new ArrayList<double[]>();
			
			for(int i=1;i<nsats+1;i++){
				double x=readDouble(s);
				double y=readDouble(s);

				sats[i]=new double[]{x,y,process(System.in)};
			}
			findPoints(sats,points);
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}
}