//@RamTararam
import java.io.*;
import java.util.*;

public class Main {
    public static int[] pattern = {30, 20, 20, 30, 30, 10, 20, 10};
    public static double EPS = 10.1;

    public static double dist2(double x1, double y1){
        return x1 * x1 + y1 * y1;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(in.readLine());

        double[] x = new double[n];
        double[] y = new double[n];
        int[] shift = new int[n];
        double[] dist = new double[n];
        int satellites = 0;

        for(int i=0; i < n && satellites < 3; ++i){
            x[satellites] = Double.parseDouble(in.readLine());
            y[satellites] = Double.parseDouble(in.readLine());

            if((satellites == 1 && dist2(x[1] - x[0], y[1] - y[0]) < EPS * EPS) ||
               (satellites == 2 && (dist2(x[2] - x[0], y[2] - y[0]) < EPS * EPS ||
                                    dist2(x[2] - x[1], y[2] - y[1]) < EPS * EPS ||
                                    Math.abs((x[2] - x[0]) * (y[0] - y[1]) / (x[0] - x[1]) + y[0] - y[2]) < EPS))){
                if(n - i + satellites > 3) {
                    in.skip(10000001);
                    continue;
                }
            }

            shift[satellites] = -170;

            int len = 0, cur = '1', j = 0;
            LinkedList<Integer> q = new LinkedList<Integer>();
            for(; j < 10000000; ++j){
                int s = in.read();
                if(s == cur)
                    len += 1;
                else{
                    q.addLast(len);
                    if(q.size() > 8) q.removeFirst();
                    if(q.size() == 8){
                        int k = 0, ok = 1;
                        for(int v : q){
                            if(v != pattern[k++]){
                                ok = 0;
                                break;
                            }
                        }
                        if(ok == 1) {
                            shift[satellites] += j;
                            break;
                        }
                    }
                    cur = s;
                    len = 1;
                }
            }
            in.skip(10000001 - j);
            dist[satellites] = shift[satellites] * 299792458L / 10000000.0;
            satellites += 1;
        }

        double x2 = x[1] - x[0],
               y2 = y[1] - y[0],
               a = -2 * x2,
               b = -2 * y2,
               c = x2 * x2 + y2 * y2 + dist[0] * dist[0] - dist[1] * dist[1],
               ab = a * a + b * b,
               cab = (1 + (dist[0] * dist[0] - dist[1] * dist[1]) / (x2 * x2 + y2 * y2))/4,
               x0 = -a * cab + x[0],
               y0 = -b * cab + y[0],
               d = dist[0] * dist[0] - c * cab,
               k = Math.sqrt(d / ab);

        double ax = x0 + b * k, ay = y0 - a * k, bx = x0 - b * k, by = y0 + a * k;
        if(ax * ax + ay * ay > 6378000L * 6378000L){
            System.out.println(bx + " " + by);
        }else if(bx * bx + by * by > 6378000L * 6378000L){
            System.out.println(ax + " " + ay);
        }else {
            int vote1 = 0, vote2 = 0;
            for (int i = 2; i < satellites; ++i) {
                double d1 = Math.abs((x[i] - ax) * (x[i] - ax) + (y[i] - ay) * (y[i] - ay) - dist[i] * dist[i]),
                       d2 = Math.abs((x[i] - bx) * (x[i] - bx) + (y[i] - by) * (y[i] - by) - dist[i] * dist[i]);
                if (Math.abs(d1 - d2) > EPS * EPS) {
                    if (d1 > d2) vote2 += 1;
                    else vote2 += 1;
                }
            }
            System.out.println(vote2 > vote1 ? bx + " " + by : ax + " " + ay);
        }
    }
}