//@blacky08
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class Main  {

	public static class Root {
		private BigDecimal x = new BigDecimal(0);
		private BigDecimal y = new BigDecimal(0);
		
		public Root(BigDecimal x, BigDecimal y) {
			this.x = x;
			this.y = y;
		}
		
		public BigDecimal getX() { return x; }
		public BigDecimal getY() { return y; }
	}
	
	public static final String START_SEQ = "111111111111111111111111111111000000000000000000001111111111111111111100000000000000000000000000000011111111111111111111111111111100000000001111111111111111111100000000001111";
	public static final int LIGHT_VELOCITY = 299792458; // meters per sec
	public static final int LENGTH_SAMPLE = 10_000;
	public static final int MAX_DISTANCE_RECEIVER = 6_378_000; //meters
	public static final int minDistanceSattelite = 10_000_000; // meters
	public static final int maxDistanceSattelite = 20_000_000; // meters
	public static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	public static long START_TIME; 
	public static long STOP_TIME;
	public static BigDecimal X_RECEIVER = new BigDecimal(0);
	public static BigDecimal Y_RECEIVER = new BigDecimal(0);
	public static int NUM_SATTELITES;
	public static double CALCULATE_ERROR = 500.0;
	public static final BigDecimal TWO = new BigDecimal(2);
	public static final BigDecimal FOUR = new BigDecimal(4);
	public static final BigDecimal EIGHT = new BigDecimal(8);
	public static final List<Root> ROOTS = new ArrayList<Root>();
	
	public static void main(String[] args) throws Exception {
		START_TIME = System.nanoTime();
		//br = new BufferedReader(new InputStreamReader(new FileInputStream("/home/dexter/workspace/Glonass/glonass-contest/test2.in")));
		//br = new BufferedReader(new InputStreamReader(new FileInputStream("/home/dexter/workspace/Glonass/glonass-contest/test3_hi_precision.in")));
		
		double xCoord[];
		double yCoord[];
		String codeSeq[];
		double distance[];
		double delay[];
		int shift[];
		BigDecimal xAvg = new BigDecimal(0);
		BigDecimal yAvg = new BigDecimal(0);
		
		NUM_SATTELITES = Integer.parseInt(br.readLine());
		if (NUM_SATTELITES > 8) {
			NUM_SATTELITES = 8;
		}
		
		xCoord = new double[NUM_SATTELITES];
		yCoord = new double[NUM_SATTELITES];
		codeSeq = new String[NUM_SATTELITES];
		distance = new double[NUM_SATTELITES];
		delay = new double[NUM_SATTELITES];
		shift = new int[NUM_SATTELITES];

		
		for(int i = 0; i < NUM_SATTELITES; i++) {
			xCoord[i] = Double.parseDouble(br.readLine());
			yCoord[i] = Double.parseDouble(br.readLine());
			codeSeq[i] = br.readLine();
		}
		
		for(int i = 0; i < NUM_SATTELITES; i++) {
			shift[i] = shiftCodeSequence(codeSeq[i], START_SEQ);
			delay[i] = getDelayCodeSequence(codeSeq[i], shift[i]);
			distance[i] = getDistance(delay[i]);
			//printSatelliteInfo(i + 1, xCoord[i], yCoord[i], 
			//		codeSeq[i].length(), shift[i], delay[i], distance[i]);
		}
		
		for(int i = 0; i < NUM_SATTELITES - 1; i++) {
			// printRoots(d1, d2, x1, x2, y1, y2)
			findRoots(distance[i], distance[i+1], xCoord[i], xCoord[i+1], yCoord[i], yCoord[i+1]);
		}

		if (ROOTS.size() > 1) {
			//int countErrorRoots[] = new int[ROOTS.size()];
			ArrayList<Integer> countErrorRoots = new ArrayList<Integer>(ROOTS.size());
			for(int i = 0; i < ROOTS.size(); i++) {
				countErrorRoots.add(0);
			}
			
			int countRightRoots = 0;
			boolean isNoErrors;
			
			do {
				int maxErrorPos = 0;
				isNoErrors = true;
				Integer max = 0;
				
				for(int i = 0; i < countErrorRoots.size(); i++) {
					countErrorRoots.set(i, new Integer(0));
				}
				
				for(int i = 0; i < ROOTS.size() - 1; i++) {
					for(int j = i + 1; j < ROOTS.size(); j++) {
						double deviationX = ROOTS.get(i).getX().subtract(ROOTS.get(j).getX()).abs().doubleValue();
						double deviationY = ROOTS.get(i).getY().subtract(ROOTS.get(j).getY()).abs().doubleValue();
						
						//System.out.printf("\t i=%d; j=%d deviationX: %+20.3f%n", i, j, deviationX);
						//System.out.printf("\t i=%d; j=%d deviationY: %+20.3f%n", i, j, deviationY);
						if (deviationX > CALCULATE_ERROR || deviationY > CALCULATE_ERROR) {
							//System.out.println("error");
							countErrorRoots.set(i, countErrorRoots.get(i) + 1); 
							countErrorRoots.set(j, countErrorRoots.get(j) + 1); 
						}
					}
				}
				
				max = Collections.max(countErrorRoots);
				
				if (max == 0)
					break;
				
				for(int i = 0; i < countErrorRoots.size(); i++) {
					
					if (countErrorRoots.get(i).equals(max)) {
						countErrorRoots.remove(max);
						ROOTS.remove(i);
						isNoErrors = false;
					}
				}
				
			} while(!isNoErrors);
			
			for(int i = 0; i < ROOTS.size(); i++) {
				if (countErrorRoots.get(i) < 2) {
					//System.out.println("Root");
					//System.out.printf("\t x: %+30.20f%n", ROOTS.get(i).getX());
					//System.out.printf("\t y: %+30.20f%n", ROOTS.get(i).getY());
					countRightRoots++;
					xAvg = xAvg.add(ROOTS.get(i).getX());
					yAvg = yAvg.add(ROOTS.get(i).getY());
				}
			}
		
			// SERIOUS MISTAKE
			if (countRightRoots == 0) {
				xAvg = ROOTS.get(0).getX();
				yAvg = ROOTS.get(0).getY();
				countRightRoots = 1;
			}
			
			xAvg = xAvg.divide(new BigDecimal(countRightRoots), RoundingMode.HALF_UP);
			yAvg = yAvg.divide(new BigDecimal(countRightRoots), RoundingMode.HALF_UP);
			
			X_RECEIVER = xAvg;
			Y_RECEIVER = yAvg;
		} else {
			if (ROOTS.size() == 1) {
				X_RECEIVER = ROOTS.get(0).getX();
				Y_RECEIVER = ROOTS.get(0).getY();
			}
		}
		
		///System.out.println("Answer");
		System.out.printf("%.3f %.3f%n%n", X_RECEIVER, Y_RECEIVER);
		
		System.out.flush();
		br.close();

		//System.out.println(genPseudoSeq(0, 174)); // 171
		STOP_TIME = System.nanoTime();
		//System.out.println("Elapsed time: " + ((double)(STOP_TIME - START_TIME)/1_000_000_000));
	}
	
	// size/shift
	public static double getDelayCodeSequence(String codeSeq, int shiftCodeSequence) {
		return (double) ((double) shiftCodeSequence / (double) codeSeq.length());
	}
	
	public static int shiftCodeSequence(String codeSeq, String startSeq) {
		return codeSeq.indexOf(startSeq);
	}
	
	
	public static void findRoots(double d1, double d2, double x1, double x2, double y1, double y2) {
		// set of equations
		// d1^2 = (x1 - xReceiver)^2 + (y1 - yReceiver)^2
		// d2^2 = (x2 - xReceiver)^2 + (y2 - yReceiver)^2
		
		BigDecimal receiverY1 = new BigDecimal(0);
		BigDecimal receiverY2 = new BigDecimal(0);
		BigDecimal receiverX1 = new BigDecimal(0);
		BigDecimal receiverX2 = new BigDecimal(0);
		BigDecimal receiverX3 = new BigDecimal(0);
		BigDecimal receiverX4 = new BigDecimal(0);
		BigDecimal part01 = new BigDecimal(0);
		BigDecimal part02 = new BigDecimal(0);
		BigDecimal part03 = new BigDecimal(0);
		BigDecimal part04 = new BigDecimal(0);
		BigDecimal part05 = new BigDecimal(0);
		BigDecimal part06 = new BigDecimal(0);
		BigDecimal part07 = new BigDecimal(0);
		
		BigDecimal D1 = new BigDecimal(d1);
		BigDecimal D2 = new BigDecimal(d2);
		BigDecimal X1 = new BigDecimal(x1);
		BigDecimal X2 = new BigDecimal(x2);
		BigDecimal Y1 = new BigDecimal(y1);
		BigDecimal Y2 = new BigDecimal(y2);
		
		/*
		//part01 = 4 * (x1 - x2) * (x1 - x2);
		//part02 = d1*d1 + 2*d1*d2 + d2*d2 - x1*x1 + 2*x1*x2 - y1*y1 + 2*y1*y2 - x2*x2 - y2*y2;
		//part03 = 2*d1*d2 - d1*d1 - d2*d2 + x1*x1 - 2*x1*x2 + y1*y1 - 2*y1*y2 + x2*x2 + y2*y2;
		//part04 = 2 * (x1 - x2);
		//part05 = 4*d1*d1*y2 - 4*d1*d1*y1 + 4*d2*d2*y1 - 4*d2*d2*y2 + 4*x1*x1*y1 + 4*x1*x1*y2 - 8*x1*y1*x2 - 8*x1*x2*y2 + 4*y1*y1*y1 - 4*y1*y1*y2 + 4*y1*x2*x2 - 4*y1*y2*y2 + 4*x2*x2*y2 + 4*y2*y2*y2;
		//part06 = 8 * (x1 - x2)*(x1 - x2);
		//part07 = 4*x1*x1 - 8*x1*x2 + 4*y1*y1 - 8*y1*y2 + 4*x2*x2 + 4*y2*y2;
		*/
		
		part01 = FOUR.multiply(X1.subtract(X2).pow(2));
		
		part02 = D1.pow(2);
		part02 = part02.add(TWO.multiply(D1).multiply(D2));
		part02 = part02.add(D2.pow(2));
		part02 = part02.subtract(X1.pow(2));
		part02 = part02.add(TWO.multiply(X1).multiply(X2));
		part02 = part02.subtract(Y1.pow(2));
		part02 = part02.add(TWO.multiply(Y1).multiply(Y2));
		part02 = part02.subtract(X2.pow(2));
		part02 = part02.subtract(Y2.pow(2));
		
		part03 = TWO.multiply(D1).multiply(D2);
		part03 = part03.subtract(D1.pow(2));
		part03 = part03.subtract(D2.pow(2));
		part03 = part03.add(X1.pow(2));
		part03 = part03.subtract(TWO.multiply(X1).multiply(X2));
		part03 = part03.add(Y1.pow(2));
		part03 = part03.subtract(TWO.multiply(Y1).multiply(Y2));
		part03 = part03.add(X2.pow(2));
		part03 = part03.add(Y2.pow(2));
		
		part04 = TWO.multiply(X1.subtract(X2));
		
		part05 = FOUR.multiply(D1.pow(2)).multiply(Y2);
		part05 = part05.subtract(FOUR.multiply(D1.pow(2)).multiply(Y1));
		part05 = part05.add(FOUR.multiply(D2.pow(2)).multiply(Y1));
		part05 = part05.subtract(FOUR.multiply(D2.pow(2).multiply(Y2)));
		part05 = part05.add(FOUR.multiply(X1.pow(2).multiply(Y1)));
		part05 = part05.add(FOUR.multiply(X1.pow(2)).multiply(Y2));
		part05 = part05.subtract(EIGHT.multiply(X1).multiply(Y1).multiply(X2));
		part05 = part05.subtract(EIGHT.multiply(X1).multiply(X2).multiply(Y2));
		part05 = part05.add(FOUR.multiply(Y1.pow(3)));
		part05 = part05.subtract(FOUR.multiply(Y1.pow(2)).multiply(Y2));
		part05 = part05.add(FOUR.multiply(Y1).multiply(X2.pow(2)));
		part05 = part05.subtract(FOUR.multiply(Y1).multiply(Y2.pow(2)));
		part05 = part05.add(FOUR.multiply(X2.pow(2).multiply(Y2)));
		part05 = part05.add(FOUR.multiply(Y2.pow(3)));

		part06 = X1.subtract(X2).pow(2).multiply(EIGHT);
		
		part07 = FOUR.multiply(X1.pow(2));
		part07 = part07.subtract(EIGHT.multiply(X1).multiply(X2));
		part07 = part07.add(FOUR.multiply(Y1.pow(2)));
		part07 = part07.subtract(EIGHT.multiply(Y1).multiply(Y2));
		part07 = part07.add(FOUR.multiply(X2.pow(2)));
		part07 = part07.add(FOUR.multiply(Y2.pow(2)));
		
		receiverY1 = sqrt(part02.multiply(part03));
		receiverY1 = receiverY1.divide(part04, RoundingMode.HALF_UP);
		receiverY1 = receiverY1.add(part05.divide(part06, RoundingMode.HALF_UP));
		receiverY1 = receiverY1.multiply(part01).divide(part07, RoundingMode.HALF_UP);
		
		receiverY2 = sqrt(part02.multiply(part03));
		receiverY2 = receiverY2.divide(part04, RoundingMode.HALF_UP);
		receiverY2 = receiverY2.subtract(part05.divide(part06, RoundingMode.HALF_UP));
		receiverY2 = receiverY2.multiply(part01).divide(part07, RoundingMode.HALF_UP);
		receiverY2 = receiverY2.negate();
		
		// (receiverX1; receiverY1), (receiverX2, receiverY1)  
		receiverX1 = X2.add(sqrt(D2.add(receiverY1).subtract(Y2)).multiply(sqrt(D2.subtract(receiverY1).add(Y2))));
		receiverX2 = X2.subtract(sqrt(D2.add(receiverY1).subtract(Y2)).multiply(sqrt(D2.subtract(receiverY1).add(Y2))));
		// (receiverX3; receiverY2), (receiverX4; receiverY2)
		receiverX3 = X2.add(sqrt(D2.add(receiverY2).subtract(Y2)).multiply(sqrt(D2.subtract(receiverY2).add(Y2))));
		receiverX4 = X2.subtract(sqrt(D2.add(receiverY2).subtract(Y2)).multiply(sqrt(D2.subtract(receiverY2).add(Y2))));

		// (receiverX1, receiverY1); (receiverX2, receiverY1)  
		// (receiverX3, receiverY2); (receiverX4, receiverY2)
		if (isRootRight(D1, D2, X1, X2, Y1, Y2, receiverX1, receiverY1)) {
			if (isReceiverLocatedWithinRadius(receiverX1, receiverY1)) {
				//System.out.println("Root #1");
				//System.out.printf("\t x1: %+30.20f%n", receiverX1);
				//System.out.printf("\t y1: %+30.20f%n", receiverY1);
				ROOTS.add(new Root(receiverX1, receiverY1));
			}
		}
		if (isRootRight(D1, D2, X1, X2, Y1, Y2, receiverX2, receiverY1)) {
			if (isReceiverLocatedWithinRadius(receiverX2, receiverY1)) {
				//System.out.println("Root #2");
				//System.out.printf("\t x2: %+30.20f%n", receiverX2);
				//System.out.printf("\t y1: %+30.20f%n", receiverY1);
				ROOTS.add(new Root(receiverX2, receiverY1));
			}
		}
		if (isRootRight(D1, D2, X1, X2, Y1, Y2, receiverX3, receiverY2)) {
			if (isReceiverLocatedWithinRadius(receiverX3, receiverY2)) {
				//System.out.println("Root #3");
				//System.out.printf("\t x3: %+30.20f%n", receiverX3);
				//System.out.printf("\t y2: %+30.20f%n", receiverY2);
				ROOTS.add(new Root(receiverX3, receiverY2));
			}
		}
		if (isRootRight(D1, D2, X1, X2, Y1, Y2, receiverX4, receiverY2)) {
			if (isReceiverLocatedWithinRadius(receiverX4, receiverY2)) {
				//System.out.println("Root #4");
				//System.out.printf("\t x4: %+30.20f%n", receiverX4);
				//System.out.printf("\t y2: %+30.20f%n", receiverY2);
				ROOTS.add(new Root(receiverX4, receiverY2));
			}
		}
		
		//System.out.println("delta(x): " + (-1816744.99061037967084015111 + 1.81683e+006));
		//System.out.println("delta(y): " + (-1743348.48546387362896178315 + 1.74334e+006));
	}
	
	public static boolean isReceiverLocatedWithinRadius(BigDecimal xReceiver, BigDecimal yReceiver) {
		// d = Math.sqrt(xReceiver*xReceiver + yReceiver*yReceiver)
		BigDecimal result = new BigDecimal(0);
		result = sqrt(xReceiver.pow(2).add(yReceiver.pow(2)));
		if (result.abs().doubleValue() > MAX_DISTANCE_RECEIVER) {
			return false;
		}
		
		return true;
	}
	
	public static boolean isRootRight(BigDecimal d1, BigDecimal d2, 
				BigDecimal x1, BigDecimal x2, 
				BigDecimal y1, BigDecimal y2,
				BigDecimal xReceiver, BigDecimal yReceiver) {
		BigDecimal result = new BigDecimal(0);
		
		// 01. check first equation
		// 0 = (x1 - xReceiver)^2 + (y1 - yReceiver)^2 - d1^2
		result = x1.subtract(xReceiver).pow(2).add(y1.subtract(yReceiver).pow(2)).subtract(d1.pow(2));
		
		if (result.abs().doubleValue() > CALCULATE_ERROR)
			return false;
		
		// 02. check second equation
		// 0 = (x2 - xReceiver)^2 + (y2 - yReceiver)^2 - d2^2
		result = x2.subtract(xReceiver).pow(2).add(y2.subtract(yReceiver).pow(2)).subtract(d2.pow(2));
				
		if (result.abs().doubleValue() > CALCULATE_ERROR)
			return false;
		
		return true;
	}
	
	
	public static double getDistance(double delay) {
		return delay * LIGHT_VELOCITY;
	}
	
	public static String genPseudoSeq(int min, int max) throws Exception {
		byte[] data;
		String PI = "3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679821480865132823066470938446";
		StringBuilder sb = new StringBuilder();
		
		for(int pos = min; pos < max; pos++) {
			String text = PI.concat(Integer.toString(((pos)%10000000/10))); 
			data = getMD5Digest(text);
			
			if (((data[0] >> 4) & 0x0F) > 7)
	        	sb.append("1");
	        else 
	        	sb.append("0");
		}
		
		return sb.toString();
	}
	
	public static byte[] getMD5Digest(String s) throws Exception {
        MessageDigest md = MessageDigest.getInstance("MD5");
        md.reset();
        md.update(s.getBytes());
        return md.digest();
	}
	
	public static BigDecimal sqrt(BigDecimal value) {
	    BigDecimal x = new BigDecimal(Math.sqrt(value.doubleValue()));
	    return x.add(new BigDecimal(value.subtract(x.multiply(x)).doubleValue() / (x.doubleValue() * 2.0)));
	}
	
	public static void printSatelliteInfo(int number, 
			double xCoord, double yCoord,
			int codeSeqLen,	int shift, 
			double delay, double distance) {
		
		System.out.printf("Satellite %d%n", number);
		System.out.printf("\t x: %+10.0f%n", xCoord);
		System.out.printf("\t y: %+10.0f%n", yCoord);
		System.out.printf("\t size of sequence: %,d%n", codeSeqLen);
		System.out.printf("\t shift: %,d%n", shift);
		System.out.printf("\t delay: %+10.10f%n", delay);
		System.out.printf("\t distance: %+10.10f%n", distance);
	}
}
