//@ds4un

import java.io.*;
import java.lang.Math;
import java.security.*;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;


public class Glonass  {
	
	public class SV {
		byte [] data = new byte[10000000];
		int delay_smp;
		double x;
		double y;
		double phi;
		String rawData;
		
		
		
		double estR(){
			double res;
			double d_x = x - pos_x; 
			double d_y = y - pos_y;
			
			res = Math.sqrt( d_x*d_x + d_y*d_y);
			return res;
		}
		
		double getR(){
			double res = -delay_smp/10e6*c_light;
			return res;
		}
		
		boolean compare(int delay, int step, int length){
			boolean res = true;
			
			for (int i=0; i<length; i+=step){
				int idx = (i + delay + 10000000) % 10000000;
				if (data[i]!=psp[idx]){
					res = false;
					break;
				}
			}
			
			return res;
		}

		void readRaw() throws IOException{
			String str = br.readLine();
			x = Double.parseDouble(str);
			str = br.readLine();
			y = Double.parseDouble(str);
			rawData = br.readLine();
			
		}
		
		void fillData(){
			byte[] rawBuf=new byte[10000000];
			rawData.getBytes(0, rawBuf.length, rawBuf, 0);
			int i=0;
			byte zero = "0".getBytes()[0];
			for (byte b : rawBuf) {
				data[i++] = (byte) (b - zero); 
			}
		}
		
		void findPos(){
			for (int delay=delay_smp-10; delay <delay_smp+10; ++delay){
				if (compare(delay, 1,1000)){
					delay_smp = delay;
					break;
				}
			}
		}
		
		void findPosRough(){
			int delay = 0;
			for ( delay=-c_delay_max; delay <-c_delay_min; delay +=10){
				if (compare(delay, 10, 10000000)){
					delay_smp = delay;
					break;
				}
			}
				
		}
		
		int findPosAssist(){
			double r = estR();
			int res = (int)(-r/c_light * 10e6);
			return res;
		}
		
		void calcPhi(double x, double y){
			;
		}
	}
	
	
	public class Matrix {

	    public int nrows;
	    public int ncols;
	    public double[][] data;

	    public Matrix(double[][] dat) {
	        this.data = dat;
	        this.nrows = dat.length;
	        this.ncols = dat[0].length;
	    }

	    public Matrix(int nrow, int ncol) {
	        this.nrows = nrow;
	        this.ncols = ncol;
	        data = new double[nrow][ncol];
	    }
	    
	    
	    public double changeSign(int i){
	    	if ((i%2)==0)
	    		return 1.;
	    	else
	    		return -1.;
	    }
	    
	    public Matrix clone(){
	    	Matrix mat = new Matrix(this.nrows, this.ncols);
		    for (int i=0;i<this.nrows;i++) {
		        for (int j=0;j<this.ncols;j++) {
		            mat.data[i][j] = this.data[i][j];
		        }
		    }
		    return mat;
	    }
	    
	    public Matrix mult(Matrix mat){
	    	
			Matrix res = new Matrix(this.nrows, mat.ncols);
			
			for (int i=0; i<res.nrows; ++i)
				for (int j=0; j<res.ncols; ++j){
					double sum = 0;
					for (int k=0; k<this.ncols; ++k){
						sum += this.data[i][k] * mat.data[k][j];
					}
					res.data[i][j]=sum;
				}
			
			return res;
	    	
	    }
	    
		public Matrix transpose(Matrix matrix) {
		    Matrix transposedMatrix = new Matrix(matrix.ncols, matrix.nrows);
		    for (int i=0;i<matrix.nrows;i++) {
		        for (int j=0;j<matrix.ncols;j++) {
		            transposedMatrix.data[j][i] = matrix.data[i][j];
		        }
		    }
		    return transposedMatrix;
		}
		public double determinant(Matrix matrix) {
		    if (matrix.ncols == 1) {
			return matrix.data[0][0];
		    }
		    if (matrix.ncols==2) {
		        return (matrix.data[0][0] * matrix.data[1][1]) - ( matrix.data[0][1] * matrix.data[1][0]);
		    }
		    double sum = 0.0;
		    for (int i=0; i<matrix.ncols; i++) {
		        sum += changeSign(i) * matrix.data[0][i] * determinant(createSubMatrix(matrix, 0, i));
		    }
		    return sum;
		}
		
		public Matrix createSubMatrix(Matrix matrix, int excluding_row, int excluding_col) {
		    Matrix mat = new Matrix(matrix.nrows-1, matrix.ncols-1);
		    int r = -1;
		    for (int i=0;i<matrix.nrows;i++) {
		        if (i==excluding_row)
		            continue;
		            r++;
		            int c = -1;
		        for (int j=0;j<matrix.ncols;j++) {
		            if (j==excluding_col)
		                continue;
		            mat.data[r][++c] = matrix.data[i][j];
		        }
		    }
		    return mat;
		}
		
		
		public Matrix cofactor(Matrix matrix) {
		    Matrix mat = new Matrix(matrix.nrows, matrix.ncols);
		    for (int i=0;i<matrix.nrows;i++) {
		        for (int j=0; j<matrix.ncols;j++) {
		            mat.data[i][j] = changeSign(i) * changeSign(j) * determinant(createSubMatrix(matrix, i, j));
		        }
		    }
		    return mat;
		}
		
		
		public Matrix multiplyByConstant(double c){
			
		    for (int i=0;i<this.nrows;i++) {
		        for (int j=0;j<this.ncols;j++) {
		            this.data[j][i] *= c;
		        }
		    }
		    return this;
		}
		
		public Matrix inverse(Matrix matrix)  {
		    return (transpose(cofactor(matrix)).multiplyByConstant(1.0/determinant(matrix)));
		}
		
		
		
	    
	}
	
	
	
	
	
	SV [] aSVs = null;
	int cntSV = 0;
	static byte[] prn = new byte[1000000];
	static byte[] prn2 = new byte[1000000];
	static byte[] prn2d = new byte[2000000];
	static BufferedReader br = null;
	static final double c_light = 299792458;
	static final int c_delay_min = (int)(10e6*(10e6-6.379e6)/c_light);
	static final int c_delay_max = (int)(10e6*(20e6+6.379e6)/c_light);
	
	static double pos_x = 0;
	static double pos_y = 0;
	static ExecutorService es;
	static int threadsCnt;
	static int cntMaxSearch;

	byte[] psp = new byte[10000000];
	static int cntSearchSV;
	
	
	void readData() throws IOException{
		String str = br.readLine();
		cntSV = Integer.parseInt(str);
		
		
		aSVs = new SV[cntSV];
		cntSearchSV =  Math.min(aSVs.length, cntMaxSearch);
		
		
		for (int i=0; i<cntSearchSV; ++i){
			aSVs[i] = new SV();
			aSVs[i].readRaw();
			aSVs[i].fillData();
		}
	}
	
	void findSVs(){
		cntSearchSV =  Math.min(aSVs.length, cntMaxSearch);
		
		long t = 0;
		for (int i=0; i<cntSearchSV; ++i){
			aSVs[i].findPosRough();
			aSVs[i].findPos();
		}
		
	}
	
	
	
	
	
	public void genPrn2(int a, int b) throws Exception{
		MessageDigest md5 = null;
		MessageDigest md5Pi = MessageDigest.getInstance("MD5");
		
		String strPi = "3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679821480865132823066470938446";
		md5Pi.update(strPi.getBytes());
		
		for (int i=a; i<b; ++i)
		{
			
			md5 = (MessageDigest)md5Pi.clone();
			md5.update(Integer.toString(i).getBytes());
			int chip = (((md5.digest()[0] >> 4) & 0x0F ) > 7 ) ? 1: 0;

			prn2[i] = (byte)chip;
			prn2d[i] = (byte)chip;
			prn2d[i+prn2d.length/2] = (byte)chip;
			for (int k=i*10; k<i*10+10; ++k){
				psp[k] = (byte)chip;
			}
			
		}
		
	}
	
	
	public class taskPRN implements Runnable{

		CountDownLatch barrier;
		int a,b;
		
		public taskPRN(int a, int b, CountDownLatch barrier){
			this.barrier = barrier;
			this.a = a;
			this.b = b;
		}

		@Override
		public void run() {
			try {
				genPrn2(a, b);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			barrier.countDown();
		}
		
		
	}
	
	public void run() throws Exception{
		
		long t =0;
		t =- System.currentTimeMillis();
		
		int N = threadsCnt;
		
		CountDownLatch barrier = new CountDownLatch(N);
		taskPRN [] tasks = new taskPRN[N];
		for (int i=0; i<N; ++i){
			
			int a = i*1000000/N;
			int b = i*1000000/N + 1000000/N;
			
			tasks[i] = new taskPRN(a, b, barrier);
			es.execute(tasks[i]);
			
			//genPrn2(a, b);
			
		}
		readData();
		
		barrier.await();
		es.shutdown();
		
		findSVs();
	}
	
	
	public void navtask(int maxSV){
		double d_x=0;
		double d_y=0;

		Matrix d_X;
		Matrix Ht;

		int N =  Math.min(cntSearchSV, maxSV);
		Matrix H = new Matrix (N,2);
		Matrix d_R = new Matrix (N,1);
		
		
		do {
			

			for (int i=0; i<N; ++i ){
				d_R.data[i][0] = aSVs[i].estR() - aSVs[i].getR();
				
				H.data[i][0] = (aSVs[i].x - pos_x)/aSVs[i].estR();
				H.data[i][1] = (aSVs[i].y - pos_y)/aSVs[i].estR();
			}
			
			Ht = H.transpose(H);
			Matrix Hinv = Ht.clone();
			
			Hinv = Hinv.mult(H);
			
			d_X  = Hinv.inverse(Hinv).mult(Ht).mult(d_R);

			
			//d_X = H.inverse(H).mult(d_R);
			
			
			d_x = d_X.data[0][0];
			d_y = d_X.data[1][0];

			
			pos_x +=d_x;
			pos_y +=d_y;
		}while (Math.sqrt(d_x*d_x + d_y*d_y) > 0.01);
		
	}
	

	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
		
		br = new BufferedReader(new InputStreamReader(System.in) ); 
		
		threadsCnt = 4;
		cntMaxSearch = 8;
		es = Executors.newFixedThreadPool(threadsCnt);

		
		
		Glonass glo = new Glonass();
		glo.run();
		
		glo.navtask(4);
		glo.navtask(cntMaxSearch);
		
		
		
		System.out.println(Double.toString(pos_x) +" " + Double.toString(pos_y));
		
		
//		double err_x = -1.81683e6 - pos_x;
//		double err_y = -1.74334e6 - pos_y;
//		
//		
//		double norm = Math.sqrt(err_x*err_x + err_y*err_y);
//		
//		System.out.println(Double.toString(norm));
//
//		System.out.println("OK");		
	}




	private void navtask2() {
		// TODO Auto-generated method stub
		
	}




	private void search2() {
		// TODO Auto-generated method stub
		
	}

}
