//@mosinnik
import java.util.Scanner;

/**
 * Created by mosinnik
 * Date: 09.05.2014 Time: 18:37
 */
public class GLONASSReceiver
{
	// bits/s
	public static final int SEND_RATE = 1_000_000;
	// ticks
	public static final int RECEIVE_RATE = 10_000_000;
	// starter string
	public static final String UNIQ_START_KEY_DECOMPRESSED = "111111111111111111111111111111000000000000000000001111111111111111111100000000000000000000000000000011111111111111111111111111111100000000001111111111111111111100000000001111111111111111111111111111110000000000111111111111111111111111111111111111111100000000000000000000";

	public static final double LIGHT_SPEED = 299_792_458;

	public static final int X_POS = 0;
	public static final int Y_POS = 1;
	public static final int RADIUS_POS = 2;

	public static void main(String[] args) throws Exception
	{
		Scanner console = new Scanner(System.in);

		int satCount = Integer.parseInt(console.nextLine());
		if(satCount > 3)
			satCount = 3;

		double[][] cycles = new double[satCount][3];
		for(int i = 0;i < satCount;i++)
		{
			cycles[i][X_POS] = Double.valueOf(console.nextLine());
			cycles[i][Y_POS] = Double.valueOf(console.nextLine());
			cycles[i][RADIUS_POS] = ((double)console.nextLine().indexOf(UNIQ_START_KEY_DECOMPRESSED)) / RECEIVE_RATE * LIGHT_SPEED;
		}
		searchReceiver(satCount, cycles);
	}

	public static void searchReceiver(int satelliteCount, double[][] satelliteCoordinates)
	{
		double x1 = satelliteCoordinates[0][X_POS];
		double y1 = satelliteCoordinates[0][Y_POS];
		double r1 = satelliteCoordinates[0][RADIUS_POS];

		double x2 = satelliteCoordinates[1][X_POS];
		double y2 = satelliteCoordinates[1][Y_POS];
		double r2 = satelliteCoordinates[1][RADIUS_POS];

		double[][] points = searchInterceptPoints(x1, y1, r1, x2, y2, r2);

		if(satelliteCount > 2)
		{
			double x3 = satelliteCoordinates[2][X_POS];
			double y3 = satelliteCoordinates[2][Y_POS];
			double r3 = satelliteCoordinates[2][RADIUS_POS];

			double[][] points2;
			if(r3 != r1)
				points2 = searchInterceptPoints(x1, y1, r1, x3, y3, r3);
			else
				points2 = searchInterceptPoints(x2, y2, r2, x3, y3, r3);


			double delta1 = Math.sqrt(Math.pow(points[0][X_POS] - points2[0][X_POS], 2) + Math.pow(points[0][Y_POS] - points2[0][Y_POS], 2));
			double delta2 = Math.sqrt(Math.pow(points[1][X_POS] - points2[0][X_POS], 2) + Math.pow(points[1][Y_POS] - points2[0][Y_POS], 2));
			double delta3 = Math.sqrt(Math.pow(points[0][X_POS] - points2[1][X_POS], 2) + Math.pow(points[0][Y_POS] - points2[1][Y_POS], 2));
			double delta4 = Math.sqrt(Math.pow(points[1][X_POS] - points2[1][X_POS], 2) + Math.pow(points[1][Y_POS] - points2[1][Y_POS], 2));

			double minDelta1 = Math.min(delta1, delta2);
			double minDelta2 = Math.min(delta3, delta4);
			double minDelta = Math.min(minDelta1, minDelta2);

			if(minDelta == delta1 || minDelta == delta3)
				System.out.println(points[0][X_POS] + " " + points[0][Y_POS]);
			else
				System.out.println(points[1][X_POS] + " " + points[1][Y_POS]);
		}
		else
			System.out.println(points[0][X_POS] + " " + points[0][Y_POS]);

	}


	public static double[][] searchInterceptPoints(double x1, double y1, double r1, double x2, double y2, double r2)
	{
		double d = Math.sqrt(Math.pow(x1 - x2, 2) + Math.pow(y1 - y2, 2));

		double a = (r1 * r1 - r2 * r2 + d * d) / (2 * d);
		double h = Math.sqrt(Math.pow(r1, 2) - Math.pow(a, 2));

		double x0 = x1 + a * (x2 - x1) / d;
		double y0 = y1 + a * (y2 - y1) / d;

		double[][] out = new double[2][2];

		out[0][X_POS] = x0 + h * (y1 - y2) / d;
		out[0][Y_POS] = y0 - h * (x1 - x2) / d;

		out[1][X_POS] = x0 - h * (y1 - y2) / d;
		out[1][Y_POS] = y0 + h * (x1 - x2) / d;

		return out;
	}

}
