//@wSpirit
import java.io.BufferedReader;
import java.io.InputStreamReader;

public class JV1 {
    static int FindMarker(String s) {
        char x = s.charAt(0);
        char x2 = s.charAt(s.length() - 1);
        int q = 0;

        if (x == x2) while (s.charAt(++q) == x){};

        for (int i = q + 10; i < s.length(); i += 10) {
            x2 = s.charAt(i);
            if (x != x2) {
                if (x == '1' && (i - q) == 190) {
                    return q - 6375480;
                } else if (x == '0' && (i - q) == 180) {
                    return q - 427400;
                }
                x = x2;
                q = i;
            }
        }
        return 0;
    }

    static class Point {double x, y;}

    static Point[] RndPt(double x1, double y1, double R1, double x2, double y2, double R2) {
        double dR = Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));    
        double dR1 = ((R1 * R1 - R2 * R2) / dR + dR) / 2;
        double xd = (x2 - x1) * (dR1 / dR) + x1;
        double yd = (y2 - y1) * (dR1 / dR) + y1;

        Point[] res = new Point[2];
        res[0] = new Point();
        res[1] = new Point();

        if (dR == 0){
            res[0].x = x1;
            res[1].x = x1;
            res[0].y = y1+R1;
            res[1].y = y1+R1;
        } else if (y1 == y2) {
            res[0].x = xd;
            res[1].x = xd;
            res[0].y = Math.sqrt(R1 * R1 - res[0].x * res[0].x);
            res[1].y = -res[0].y;
        } else {
            double k = -(xd - x1) / (yd - y1);
            double kb = yd - k * xd;
            double b = - 2 * xd;
            double c = ((kb - y1) * (kb - y1) + x1 * x1 - R1 * R1) / (k * k + 1);
            double D = b * b - 4 * c;
            if (D <= 0) {
                res[0].x = xd;
                res[1].x = xd;
                res[0].y = yd;
                res[1].y = yd;
            } else {
                res[0].x = (-b - Math.sqrt(D)) / 2;
                res[1].x = (-b + Math.sqrt(D)) / 2;
                res[0].y = k * res[0].x + kb;
                res[1].y = k * res[1].x + kb;
            }
        }
        return res;
    }

    static final double CSpeed = 29.9792458;

    public static void main(String[] args) {
        int cnt = 0;
        double[] xs=null,ys=null,r=null;
             
        try {
            BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
            
            cnt = Integer.parseInt(in.readLine());
            xs = new double[cnt];
            ys = new double[cnt];
            r = new double[cnt];

            for (int i = 0; i < cnt; ++i) {
                xs[i] = Double.parseDouble(in.readLine());
                ys[i] = Double.parseDouble(in.readLine());
                r[i] = FindMarker(in.readLine()) * CSpeed;
            }
        } catch (Exception e) {}
        
        Point[] pts1, pts = null;
        double minAng = Double.MAX_VALUE;
        boolean fin = false;
        for (int i = 0; i < cnt; ++i) {
            for (int j = i + 1; j < cnt; ++j) {
                pts1 = RndPt(xs[i], ys[i], r[i], xs[j], ys[j], r[j]);
                double ax = xs[i] - pts1[0].x;
                double ay = ys[i] - pts1[0].y;
                double bx = xs[j] - pts1[0].x;
                double by = ys[j] - pts1[0].y;

                double cosa = Math.acos((ax * bx + ay * by) / Math.sqrt((ax * ax + ay * ay) * (bx * bx + by * by))) * 180 / Math.PI;
                if (cosa >= 70 && cosa <= 110) {
                    minAng = 18;
                    pts = pts1;
                    fin = true;
                    break;
                }
                cosa = Math.abs(cosa - 90);
                if (cosa < minAng) {
                    pts = pts1;
                    minAng = cosa;
                }
            }
            if (fin) break;
        }

        double sqr = CSpeed;
        if (minAng > 20) sqr = 2 * CSpeed;

        double[] resx = new double[2];
        double[] resy = new double[2];
        double[] minNr = new double[2];
        double sumnr;

        for (int k = 0; k < 2; ++k) {
            minNr[k] = Double.MAX_VALUE;
            for (double x = pts[k].x - sqr; x < pts[k].x + sqr; x += 0.5) {
                for (double y = pts[k].y - sqr; y < pts[k].y + sqr; y += 0.5) {
                    sumnr = 0;
                    for (int i = 0; i < cnt; ++i) {
                        double nr = Math.abs(r[i] - Math.sqrt((x - xs[i]) * (x - xs[i]) + (y - ys[i]) * (y - ys[i])));
                        if (nr < CSpeed / 2) nr /= 4; else nr *= 4;
                        sumnr += nr;
                    }
                    if (sumnr < minNr[k]) {
                        resx[k] = x;
                        resy[k] = y;
                        minNr[k] = sumnr;
                    }
                }
            }
        }

        double dist0 = Math.sqrt(resx[0] * resx[0] + resy[0] * resy[0]);
        double dist1 = Math.sqrt(resx[1] * resx[1] + resy[1] * resy[1]);
        int resk;
        if (dist0 <= 6378000 && dist1 >= 6378000) resk = 0;
        else if (dist0 >= 6378000 && dist1 <= 6378000) resk = 1;
        else {
            if (minNr[0] > minNr[1]) resk = 1; else resk = 0;
        }
        System.out.println(resx[resk] + " " + resy[resk]);
    }
}
